#ifndef _H_3DVectorDefs
#define _H_3DVectorDefs
#pragma once

#include "CAxisAngle.h"

// This is our 3D point class + angle.
class CVector4 
{
public:
						CVector4() : x(0.0f), y(0.0f), z(0.0f), w(0.0f) { }
						
						CVector4(
							float	inX,
							float	inY,
							float	inZ,
							float	inW = 0.0) :
								x(inX), y(inY), z(inZ), w(inW) { }

	inline	void		Set(
							float	inX,
							float	inY,
							float	inZ,
							float	inW = 0.0)
						{
							x = inX; y = inY; z = inZ; w = inW;
						}
						
	inline operator		const float*() const
							{ return &x; }

	inline bool			operator==(const CVector4& inRhs) const
							{ return x == inRhs.x && y == inRhs.y && z == inRhs.z && w == inRhs.w; }

	inline bool			operator!=(const CVector4& inRhs) const
							{ return x != inRhs.x || y != inRhs.y || z != inRhs.z || w != inRhs.w; }

	float x, y, z, w;
};

#include "CFloatXYZ.h"
#include "CFloatXY.h"

/*
// This is our 3D point class.  This will be used to store the vertices of our model.
class CVector3 
{
public:
	CVector3()
	{
		x = y = z = 0.0f;
	}
	
	CVector3(
		float	inX,
		float	inY,
		float	inZ)
	{
		x = inX;
		y = inY;
		z = inZ;
	}

	inline const float*	GetFloatValuePtr() const
							{ return &x; }

	inline bool	operator==(const CVector3& inRhs)
					{ return x == inRhs.x && y == inRhs.y && z == inRhs.z; }
	
	inline bool	operator!=(const CVector3& inRhs)
					{ return x != inRhs.x || y != inRhs.y || z != inRhs.z; }

	float x, y, z;
};

// This is our 2D point class.  This will be used to store the UV coordinates.
class CVector2 
{
public:
	CVector2()
	{
		x = y = 0.0f;
	}
	
	CVector2(
		float	inX,
		float	inY)
	{
		x = inX;
		y = inY;
	}

	inline const float*	GetFloatValuePtr() const
							{ return &x; }

	inline bool	operator==(const CVector2& inRhs)
					{ return x == inRhs.x && y == inRhs.y; }

	inline bool	operator!=(const CVector2& inRhs)
					{ return x != inRhs.x || y != inRhs.y; }

	float x, y;
};
*/

#endif
