//============================================================================
//	CoreImageBase				(c) 2007 Mark F. Coniglio. All rights reserved
// ===========================================================================

#ifndef _H_CoreImageBase
#define	_H_CoreImageBase
#pragma once

// system includes
#include "OpenGLIncludes.h"

// isadora includes
#include "IsadoraTypes.h"
#include "IsadoraDebugging.h"

// other includes
#include "ValueCommon.h"
#include "CoreImageCompatibility.h"

// ===========================================================================
// CoreImageBuffer struct

struct CoreImageBuffer
{
	DataValueInfo	mInfo;					// our data value info struct - required
	UInt32			mMagic;					// always kCoreImageBufferMagic for valid buffers
	CI_Image		mImage;					// the image
	StageIndexT		mTargetStageIndex0;		// destination stage for the buffer - type should match StageIndexT
};

typedef struct CoreImageBuffer	CoreImageBuffer, *CoreImageBufferPtr;

// ===========================================================================
// Core Image Buffer Magic Value

// used to markk a Core Image Buffer as valid

#define kCoreImageBufferMagic		0x12345678

#endif	// #ifndef _H_CoreImageBase
