// ===========================================================================
//	CoreImageCompatibility	   (c) 2015 Mark F. Coniglio. All rights reserved.
// ===========================================================================
//
// Used to allow C and Cocoa code to share references to Cocoa objects. For
// Cocoa files, it is important to include <Cocoa/Cocoa.h> before including
// this header; this will cause the typedefs below to refer to the actual
// Cocoa types. Otherwise, all Cocoa types will point opaque structs
// so that they can be referenced in C code.
 
#ifndef _H_CoreImageCompatibility
#define	_H_CoreImageCompatibility

#include "CoreImageCommon.h"

// ===========================================================================
// COCOA TYPES

#if COMPILE_CORE_VIDEO && defined(_OBJC_OBJC_H_)

	#import <QuartzCore/QuartzCore.h>
	#import <QuartzCore/CIVector.h>
	#import <QuartzCore/CIFilter.h>
	#import <Quartz/Quartz.h>
		
	typedef NSBitmapImageRep*					NS_BitmapImageRep;
	typedef NSGraphicsContext*					NS_GraphicsContext;
	typedef NSFont*								NS_Font;
	typedef CIContext*							CI_Context;
	typedef CIImage*							CI_Image;
	typedef NSImage*							NS_Image;
	typedef CIFilter*							CI_Filter;
	typedef CI_Filter							CI_ColorMatrixFilter;
	typedef QCRenderer*							QC_Renderer;
	typedef NSOpenGLContext*					NS_OpenGLContext;
	// typedef NSOpenGLPixelBuffer*				NS_OpenGLPixelBuffer;	// 3.0.8b9 -- removed
	typedef NSDictionary*						NS_Dictionary;
	
#else

	typedef struct OpaqueNSBitmapImageRep*		NS_BitmapImageRep;
	typedef struct OpaqueNSGraphicsContext*		NS_GraphicsContext;
	typedef struct OpaqueNSFont*				NS_Font;
	typedef struct OpaqueCIContext*				CI_Context;
	typedef struct OpaqueCIImage*				CI_Image;
	typedef struct OpaqueNSImage*				NS_Image;
	typedef struct OpaqueCIFilter*				CI_Filter;
	typedef CI_Filter							CI_ColorMatrixFilter;
	typedef struct OpaqueQCRenderer*			QC_Renderer;
	typedef struct OpaqueNSOpenGLContext*		NS_OpenGLContext;
	// typedef struct OpaqueNSOpenGLPixelBuffer* NS_OpenGLPixelBuffer;	// 3.0.8b9 -- removed
	typedef struct OpaqueNSDictionary*			NS_Dictionary;
	
#endif

// ===========================================================================
// CV_ImageBufferRef TYPE

#if COMPILE_CORE_VIDEO
	#include <CoreVideo/CoreVideo.h>
	typedef CVImageBufferRef					CV_ImageBufferRef;
#else
	typedef struct OpaqueCVImageBufferRef*		CV_ImageBufferRef;
#endif

#endif	// #ifndef CoreImageCompatibility
