// =================================================================================
//	IZQDTypes						(c) 2018 Mark F. Coniglio -- All Rights Reserved
// =================================================================================
// Replacement for QuickTime/Macintosh structures

#ifndef _H_IZQDTypes
#define _H_IZQDTypes

#include "IZDefinitions.h"

#if PRAGMA_STRUCT_PACKPUSH
	#pragma pack(push, 2)
#else
	#pragma options align=mac68k
#endif

typedef UInt16	QDSmallFract;

struct QDHSVColor {
	QDSmallFract	hue;                    /* Fraction of circle, red at 0 */
	QDSmallFract	saturation;             /* 0-1, 0 for gray, 1 for pure color */
	QDSmallFract	value;                  /* 0-1, 0 for black, 1 for max intensity */
};

typedef struct	QDHSVColor	QDHSVColor;

struct QDHSLColor {
	QDSmallFract	hue;                    /* Fraction of circle, red at 0 */
	QDSmallFract	saturation;             /* 0-1, 0 for gray, 1 for pure color */
	QDSmallFract	lightness;              /* 0-1, 0 for black, 1 for white */
};

typedef struct QDHSLColor	QDHSLColor;

#ifndef __QUICKDRAW__
struct RGBColor {
  unsigned short      red;                    /*magnitude of red component*/
  unsigned short      green;                  /*magnitude of green component*/
  unsigned short      blue;                   /*magnitude of blue component*/
};
typedef struct RGBColor                 RGBColor;
typedef RGBColor *                      RGBColorPtr;
typedef RGBColorPtr *                   RGBColorHdl;
#endif


#if PRAGMA_STRUCT_PACKPUSH
	#pragma pack(pop)
#else
	#pragma options align=reset
#endif


#endif	// #ifndef _H_IZQDTypes