// =================================================================================
//	IZQT						(c) 2016 Mark F. Coniglio -- All Rights Reserved
// =================================================================================
//
// The header files that begin with IZQT exist to replace functionality offered
// previously by Apple's QuickTime. When the IZ_ALLOW_QUICKTIME flag is true, then
// the real QuickTime calls will be used. Otherwise, defines which start with >QT"
// replace the QuickTime functions. For example, NewHandle should always be written
// as QTNewHandle to allow Isadora plugins to compile without the use of QuickTime

#if defined(_MSC_VER) || defined(_WIN32) || defined(_WIN64)
#include <ConditionalMacros.h>
#endif

#ifndef _H_IZQT
#define _H_IZQT

// for windows compilers
#if _WIN32 || _WIN64
	#define	IZ_64BIT				_WIN64
	#define	IZ_32BIT				!IZ_64BIT
// for macos compilers
#else
	#define	IZ_64BIT				__LP64__
	#define	IZ_32BIT				!IZ_64BIT
#endif

#ifndef IZ_LINK_QUICKTIME_LIB
#define IZ_LINK_QUICKTIME_LIB		FALSE
#endif

#ifndef IZ_ALLOW_QUICKTIME
#define	IZ_ALLOW_QUICKTIME			(TARGET_OS_MAC && IZ_LINK_QUICKTIME_LIB)
#endif

#ifndef IZ_ALLOW_AVFOUNDATION
#define	IZ_ALLOW_AVFOUNDATION		(TARGET_OS_MAC && IZ_64BIT)
#endif

#ifndef ALLOW_MAC_ALIASES
#define	ALLOW_MAC_ALIASES			FALSE
#endif

#ifndef IZ_COMPOSITE_WINDOWS
#define	IZ_COMPOSITE_WINDOWS		TRUE
#endif

#ifndef IZ_ALLOW_QUICKDRAW
#define	IZ_ALLOW_QUICKDRAW			FALSE
#endif

#if _WIN64 || _WIN32
#include <MacTypes.h>
#include <Resources.h>
#endif

#include "IZDefinitions.h"			// Core Definitions
#include "iz_string.h"				// additional string functions

//#include "IZEvent.h"				// Events
//#include "IZTime.h"				// Time Functions
//#include "IZMenus.h"				// Menu Functions
//#include "IZWIndows.h"			// Windows Related Function
//#include "IZView.h"				// Native View Functions
//#include "IZDrag.h"				// Drag and Drop Implementation
//#include "IZQTSystem.h"			// System Functions
//#include "IZQTMemory.h"			// Memory Functions
//#include "IZQTRegion.h"			// Region Functions
//#include "IZQTResources.h"		// Resource File Functions (i.e., .rsrc and .ppob)
//#include "IZQTDebugging.h"		// Debugging Function

#endif