// ===========================================================================
//	IsadoraDebugging			(C) 2014 Mark F. Coniglio. All rights reserved
// ===========================================================================

#ifndef _H_IsadoraDebugging
#define _H_IsadoraDebugging

#ifndef __ISADORA_APP__		// if not compiling the Isadora application

	// these are used only when NOT compiling
	// the Isadora application

	// IzzyLogInfo_: this define is used throughout
	// the SDK to define allow logging functions that
	// only execute in the DEBUG version, but compile
	// out in the NDEBUG (release) version
	//
	// Customize this by #defing your own IzzyLogInfo_
	// Your custom function must expect a variable 
	// parameter list just like the printf function.
	//
	// void IzzyLogInfo_(...)
	//
	
	#ifndef IzzyLogInfo_
		
		#if DEBUG
			#define	IzzyLogInfo_			printf
		#else
			#define	IzzyLogInfo_(...)		{ }
		#endif
		
	#endif

	#ifndef IzzyLogFlush_
		
		#if DEBUG
			#define	IzzyLogFlush_			fflush
		#else
			#define	IzzyLogFlush_(...)		{ }
		#endif
		
	#endif

	// IzzyAssert_: this define is used throughout
	// the SDK to define raise assertions in both the
	// DEBUG and NDEBUG (release) versions.
	//
	// Customize this by #defing your own IzzyAssert_
	//
	// void IzzyAssert_(bool mustBeTrueOrAssertionThrown)
	//
	
	#ifndef IzzyAssert_
		#define	IzzyAssert_					assert
	#endif

	// IzzyDebugAssert_: this define is used throughout
	// the SDK to define raise assertions in the DEBUG
	// version only. It will compile out in the NDEBUG
	// (release) version
	//
	// Customize this by #defing your own IzzyDebugAssert_
	//
	// void IzzyDebugAssert_(bool mustBeTrueOrAssertionThrown)
	//
	
	#ifndef IzzyDebugAssert_
	
		#if DEBUG
			#define	IzzyDebugAssert_		assert
		#else
			#define	IzzyDebugAssert_(...)	{ }
		#endif
		
	#endif

#else
	
	// these are used only when compiling
	// the Isadora application

	#define	IzzyLogInfo_					log_info
	
	#define	IzzyAssert_						Assert_
	
	#if DEBUG
		#define	IzzyDebugAssert_			Assert_
	#else
		#define	IzzyDebugAssert_(...)		{ }
	#endif

#endif

#endif
