// =================================================================================
//	IsadoraPluginPrefix				  �2010 Mark F. Coniglio -- All Rights Reserved.
// =================================================================================

#ifdef ISADORA_PLUGIN

#ifndef _H_IsadoraPluginPrefix
#define _H_IsadoraPluginPrefix

	// UNDEFINE NDEBUG IF NEEDED
	// Isadora defines the NDEBUG switch as 0 for Debug versions,
	// and 1 for Release versions. This however causes a problem
	// for assert.h becasue it determines the activation of the
	// assert statement based on NDEBUG being defined or not. So
	// we need to temporarily undefine it before we include assert.h
	// to ensure the correct behavior

	#if DEBUG
		#ifdef NDEBUG
			#define ISADORA_PLUGIN_NDEBUG_WAS_DEFINED	1
			#undef NDEBUG
		#else
			#define ISADORA_PLUGIN_NDEBUG_WAS_DEFINED	0
		#endif
	#endif

	// INCLUDE ASSERT.H WITH CORRECT DEFINE STATUS OF NDEBUG

	#include <assert.h>

	// INCUDE REMAINING HEADERS

	#ifdef __LP64__
		#ifdef __arm64__
			#define __MAC_X86_64_BIT__	0
			#define __WIN_X86_64_BIT__	0
			#define __MAC_ARM_64_BIT__	1
			#define __WIN_ARM_64_BIT__	0
		#else
			#define __MAC_X86_64_BIT__	1
			#define __WIN_X86_64_BIT__	0
			#define __MAC_ARM_64_BIT__	0
			#define __WIN_ARM_64_BIT__	0
		#endif
	#endif

	#ifdef _WIN64
		#ifdef _M_ARM64
			#define __MAC_X86_64_BIT__	0
			#define __WIN_X86_64_BIT__	1
			#define __MAC_ARM_64_BIT__	0
			#define __WIN_ARM_BIT__		0
		#else
			#define __MAC_X86_64_BIT__	0
			#define __WIN_X86_64_BIT__	1
			#define __MAC_ARM_64_BIT__	0
			#define __WIN_ARM_64_BIT__	0
		#endif
	#endif

	#if __MAC_X86_64_BIT__ || __WIN_X86_64_BIT__

		// define _STDINT_H to ensure the QTML version 
		// of stdint.his not included
		#ifndef _STDINT_H
		#define _STDINT_H
		#endif

		// define __FP__ to ensure the QTML file fp.h
		// is not included
		#ifndef __FP__
		#define __FP__
		#endif

		#define ACCESSOR_CALLS_ARE_FUNCTIONS		1

		// from ConditionalMacros.h: updated for x64 compilation.

		#define TARGET_CPU_PPC						0
		#define TARGET_CPU_68K						0
		#define TARGET_CPU_X86						0
		#define TARGET_CPU_X86_64					1
		#define TARGET_CPU_ARM64					0
		#define TARGET_CPU_MIPS						0
		#define TARGET_CPU_SPARC					0
		#define TARGET_CPU_ALPHA					0

		#if __MAC_X86_64_BIT__ || __MAC_ARM_64_BIT__
		#define TARGET_OS_MAC						1
		#define TARGET_OS_WIN						0
		#endif

		#if __WIN_X86_64_BIT__ || __WIN_ARM_64_BIT__
		#define TARGET_OS_MAC						0
		#define TARGET_OS_WIN						1
		#endif

		#define TARGET_OS_UNIX						0
		#define TARGET_RT_LITTLE_ENDIAN				1
		#define TARGET_RT_BIG_ENDIAN				0
		
		#if __WIN_X86_64_BIT__ || __WIN_ARM_64_BIT__
		#define __COREAUDIO_USE_FLAT_INCLUDES__
		#endif

		#define PRAGMA_IMPORT						0
		#define PRAGMA_STRUCT_ALIGN 				0
		#define PRAGMA_ONCE							0
		#define PRAGMA_STRUCT_PACK					1
		#define PRAGMA_STRUCT_PACKPUSH				1
		#define PRAGMA_ENUM_PACK 					0
		#define PRAGMA_ENUM_ALWAYSINT				0
		#define PRAGMA_ENUM_OPTIONS					0
		#define FOUR_CHAR_CODE(x)					(x) 
		#define TYPE_LONGDOUBLE_IS_DOUBLE			1
		#define TYPE_EXTENDED						0
		#define TYPE_LONGLONG						1   /* note: uses __int64 instead of long long */
		#define LONGLONG_TYPENAME					__int64

		#define LONGLONG_SIGNED_MAX					(9223372036854775807i64)
		#define LONGLONG_SIGNED_MIN					(-9223372036854775807i64 - 1)
		#define LONGLONG_UNSIGNED_MAX				(0xffffffffffffffffui64)

		#define TYPE_BOOL							1
		#define FUNCTION_PASCAL						0
		#ifndef FUNCTION_DECLSPEC							/* allow use of __declspec(dllimport) to be enabled */
		#define FUNCTION_DECLSPEC					0		/* QuickTime for Windows cannot use dllimport */
		#endif
		#ifndef FUNCTION_WIN32CC							/* allow calling convention to be overriddden */
		#define FUNCTION_WIN32CC					1   
		#endif

		/* Warning:  This macros away the pascal word in source code. */
		/* Very useful for code that needs to compile on Mac 68k and Windows */
		/* but can silently change code */
		#undef pascal
		#define pascal

	#endif	// #if __MAC_X86_64_BIT__ || __WIN_X86_64_BIT__

	#if __MAC_ARM_64_BIT__ || __WIN_ARM_64_BIT__

		// define _STDINT_H to ensure the QTML version 
		// of stdint.his not included
		#define _STDINT_H

		// define __FP__ to ensure the QTML file fp.h
		// is not included
		#define __FP__

		#define ACCESSOR_CALLS_ARE_FUNCTIONS		1

		// from ConditionalMacros.h: updated for x64 compilation.

		#define TARGET_CPU_PPC						0
		#define TARGET_CPU_68K						0
		#define TARGET_CPU_X86						0
		#define TARGET_CPU_X86_64					0
		#define TARGET_CPU_ARM64					1
		#define TARGET_CPU_MIPS						0
		#define TARGET_CPU_SPARC					0
		#define TARGET_CPU_ALPHA					0

		#if __MAC_X86_64_BIT__ || __MAC_ARM_64_BIT__
		#define TARGET_OS_MAC						1
		#define TARGET_OS_WIN						0
		#endif

		#if __WIN_X86_64_BIT__ || __WIN_ARM_64_BIT__
		#define TARGET_OS_MAC						0
		#define TARGET_OS_WIN						1
		#endif

		#define TARGET_OS_UNIX						0
		#define TARGET_RT_LITTLE_ENDIAN				1
		#define TARGET_RT_BIG_ENDIAN				0
		
		#if __WIN_X86_64_BIT__ || __WIN_ARM_64_BIT__
		#define __COREAUDIO_USE_FLAT_INCLUDES__
		#endif

		#define PRAGMA_IMPORT						0
		#define PRAGMA_STRUCT_ALIGN 				0
		#define PRAGMA_ONCE							0
		#define PRAGMA_STRUCT_PACK					1
		#define PRAGMA_STRUCT_PACKPUSH				1
		#define PRAGMA_ENUM_PACK 					0
		#define PRAGMA_ENUM_ALWAYSINT				0
		#define PRAGMA_ENUM_OPTIONS					0
		#define FOUR_CHAR_CODE(x)					(x) 
		#define TYPE_LONGDOUBLE_IS_DOUBLE			1
		#define TYPE_EXTENDED						0
		#define TYPE_LONGLONG						1   /* note: uses __int64 instead of long long */
		#define LONGLONG_TYPENAME					__int64

		#define LONGLONG_SIGNED_MAX					(9223372036854775807i64)
		#define LONGLONG_SIGNED_MIN					(-9223372036854775807i64 - 1)
		#define LONGLONG_UNSIGNED_MAX				(0xffffffffffffffffui64)

		#define TYPE_BOOL							1
		#define FUNCTION_PASCAL						0
		#ifndef FUNCTION_DECLSPEC							/* allow use of __declspec(dllimport) to be enabled */
		#define FUNCTION_DECLSPEC					0		/* QuickTime for Windows cannot use dllimport */
		#endif
		#ifndef FUNCTION_WIN32CC							/* allow calling convention to be overriddden */
		#define FUNCTION_WIN32CC					1   
		#endif

		/* Warning:  This macros away the pascal word in source code. */
		/* Very useful for code that needs to compile on Mac 68k and Windows */
		/* but can silently change code */
		#undef pascal
		#define pascal

	#endif	// #if __MAC_ARM_64_BIT__ || __WIN_ARM_64_BIT__

	#ifdef WIN32
		#include <windows.h>
		#include <math.h>
		#include <stdint.h>
		#include <qtml.h>
	#endif

	#if TARGET_OS_MAC
		#include <Carbon/Carbon.h>
	#endif
	#if !defined(DONT_DEFINE_SNPRINTF)
	#if TARGET_OS_WIN
	#if _MSC_VER < 1910
		#define snprintf	_snprintf
	#endif
	#endif
	#endif

	#if DEBUG
	
		#define		log_info				printf
		#define		log_info_verbose		printf
		#define		log_flush				fflush
		#define		dbgassert				assert

	#else

		#define		log_info(...)			{ }
		#define		log_info_verbose(...) 	{ }
		#define		log_flush(...)			{ }
		#define		dbgassert(...)			{ }

	#endif

	#if DEBUG
	
		#define		log_info				printf
		#define		log_info_verbose		printf
		#define		log_flush				fflush
		#define		dbgassert				assert

	#else

		#define		log_info(...)			{ }
		#define		log_info_verbose(...) 	{ }
		#define		log_flush(...)			{ }
		#define		dbgassert(...)			{ }

	#endif


	#include "izzy_math.h"
	#include "IsadoraDebugging.h"

	// TO ALLOW CROSSPLATFORM MARKING OF UNUSED VARIABLES
	#define	UNUSED_VAR(x)	{ (void) x; }

	// REDEFINE NDEBUG IF NEEDED
	#if DEBUG
		#ifdef ISADORA_PLUGIN_NDEBUG_WAS_DEFINED
			#define NDEBUG	0
		#endif
	#endif

#endif

#endif