// =================================================================================
//	iz_string						(c) 2018 Mark F. Coniglio -- All Rights Reserved
// =================================================================================

#ifndef _H_iz_string
#define _H_iz_string

#include <string.h>

#define IZ_STRING_INLINE	TRUE

#ifdef _MSC_VER
#pragma warning(disable: 4996) // disable warning 4996
#endif

#ifdef __cplusplus

namespace std {

#if IZ_STRING_INLINE

	inline size_t strncpy_s(char* dst, const char* src, size_t dsize)
	{
		#if 0
			const char *osrc = src;
			size_t nleft = dsize;
	
			// Copy as many bytes as will fit.
			if (nleft != 0) {
				while (--nleft != 0) {
					if ((*dst++ = *src++) == '\0')
						break;
				}
			}

			// Not enough room in dst, add NUL and traverse rest of src.
			if (nleft == 0) {
				if (dsize != 0) {
					*dst = '\0';		// NUL-terminate dst
				}
				while (*src++)
					;
			}

			return(src - osrc - 1);	// count does not include NUL

		#else

			if (dsize > 0) {
				strncpy(dst, src, dsize);
				dst[dsize-1] = 0;
			}
			return 0;
	
		#endif
	}

	inline size_t strncat_s(char* dst, const char*  src, size_t dsize)
	{
		#if 0
			char *d = dst;
			const char *s = src;
			size_t n = dsize;
			size_t dlen;

			// Find the end of dst and adjust bytes left but don't go past end
			while (n-- != 0 && *d != '\0')
				d++;
			dlen = d - dst;
			n = dsize - dlen;

			if (n == 0) {
				*(dst + dsize - 1) = 0;
				return (dlen + strlen(s));
			}
			while (*s != '\0') {
				if (n != 1) {
					*d++ = *s;
					n--;
				}
				s++;
			}
			*d = '\0';

			return(dlen + (s - src));	// count does not include NUL

		#else

			if (dsize > 0) {
				strncat(dst, src, dsize);
				dst[dsize-1] = 0;
			}
			return 0;
	
		#endif
	
	}

#else

	size_t strncpy_s(char * dst, const char * src, size_t dsize);
	size_t strncat_s(char * dst, const char *  src, size_t dsize);
	

#endif

}
#endif	// #ifdef __cplusplus

#ifdef _MSC_VER
#pragma warning(default: 4996) // enable warning 4345 back
#endif

#endif	// #ifndef _H_IZOpenGL